Index: channels/chan_pjsip.c
===================================================================
--- channels/chan_pjsip.c	(revision 430751)
+++ channels/chan_pjsip.c	(working copy)
@@ -1329,6 +1329,8 @@
 	pj_str_t tmp;
 
 	if (pjsip_inv_end_session(session->inv_session, 302, NULL, &packet) != PJ_SUCCESS) {
+		ast_log(LOG_WARNING, "Failed to redirect PJSIP session for channel %s\n",
+			ast_channel_name(session->channel));
 		message = AST_TRANSFER_FAILED;
 		ast_queue_control_data(session->channel, AST_CONTROL_TRANSFER, &message, sizeof(message));
 
@@ -1341,6 +1343,8 @@
 
 	pj_strdup2_with_null(packet->pool, &tmp, target);
 	if (!(contact->uri = pjsip_parse_uri(packet->pool, tmp.ptr, tmp.slen, PJSIP_PARSE_URI_AS_NAMEADDR))) {
+		ast_log(LOG_WARNING, "Failed to parse destination URI '%s' for channel %s\n",
+			target, ast_channel_name(session->channel));
 		message = AST_TRANSFER_FAILED;
 		ast_queue_control_data(session->channel, AST_CONTROL_TRANSFER, &message, sizeof(message));
 		pjsip_tx_data_dec_ref(packet);
@@ -1382,14 +1386,28 @@
 static int transfer(void *data)
 {
 	struct transfer_data *trnf_data = data;
+	struct ast_sip_endpoint *endpoint = NULL;
+	struct ast_sip_contact *contact = NULL;
+	const char *target = trnf_data->target;
 
+	/* See if we have an endpoint; if so, use its contact */
+	endpoint = ast_sorcery_retrieve_by_id(ast_sip_get_sorcery(), "endpoint", target);
+	if (endpoint) {
+		contact = ast_sip_location_retrieve_contact_from_aor_list(endpoint->aors);
+		if (contact && !ast_strlen_zero(contact->uri)) {
+			target = contact->uri;
+		}
+	}
+
 	if (ast_channel_state(trnf_data->session->channel) == AST_STATE_RING) {
-		transfer_redirect(trnf_data->session, trnf_data->target);
+		transfer_redirect(trnf_data->session, target);
 	} else {
-		transfer_refer(trnf_data->session, trnf_data->target);
+		transfer_refer(trnf_data->session, target);
 	}
 
 	ao2_ref(trnf_data, -1);
+	ao2_cleanup(endpoint);
+	ao2_cleanup(contact);
 	return 0;
 }
 
Index: include/asterisk/stasis_app.h
===================================================================
--- include/asterisk/stasis_app.h	(revision 430751)
+++ include/asterisk/stasis_app.h	(working copy)
@@ -486,6 +486,8 @@
  */
 int stasis_app_control_continue(struct stasis_app_control *control, const char *context, const char *extension, int priority);
 
+int stasis_app_control_redirect(struct stasis_app_control *control, const char *endpoint);
+
 /*!
  * \brief Indicate ringing to the channel associated with this control.
  *
Index: res/ari/resource_channels.c
===================================================================
--- res/ari/resource_channels.c	(revision 430751)
+++ res/ari/resource_channels.c	(working copy)
@@ -156,6 +156,64 @@
 	ast_ari_response_no_content(response);
 }
 
+void ast_ari_channels_redirect(struct ast_variable *headers,
+	struct ast_ari_channels_redirect_args *args,
+	struct ast_ari_response *response)
+{
+	RAII_VAR(struct stasis_app_control *, control, NULL, ao2_cleanup);
+	RAII_VAR(struct ast_channel_snapshot *, chan_snapshot, NULL, ao2_cleanup);
+	char *tech;
+	char *resource;
+	int tech_len;
+
+	control = find_control(response, args->channel_id);
+	if (!control) {
+		return;
+	}
+
+	if (ast_strlen_zero(args->endpoint)) {
+		ast_ari_response_error(response, 400, "Not Found",
+			"Required parameter 'endpoint' not provided.");
+		return;
+	}
+
+	tech = ast_strdupa(args->endpoint);
+	if (!(resource = strchr(tech, '/')) || !(tech_len = resource - tech)) {
+		ast_ari_response_error(response, 422, "Unprocessable Entity",
+			"Endpoint parameter '%s' does not contain tech/resource", args->endpoint);
+		return;
+	}
+
+	*resource++ = '\0';
+	if (ast_strlen_zero(resource)) {
+		ast_ari_response_error(response, 422, "Unprocessable Entity",
+			"No resource provided in endpoint parameter '%s'", args->endpoint);
+		return;
+	}
+
+	chan_snapshot = ast_channel_snapshot_get_latest(args->channel_id);
+	if (!chan_snapshot) {
+		ast_ari_response_error(response, 500, "Internal Server Error",
+			"Unable to find channel snapshot for '%s'", args->channel_id);
+		return;
+	}
+
+	if (strncasecmp(chan_snapshot->type, tech, tech_len)) {
+		ast_ari_response_error(response, 422, "Unprocessable Entity",
+			"Endpoint technology '%s' does not match channel technology '%s'",
+			tech, chan_snapshot->type);
+		return;
+	}
+
+	if (stasis_app_control_redirect(control, resource)) {
+		ast_ari_response_error(response, 500, "Internal Server Error",
+			"Failed to redirect channel");
+		return;
+	}
+
+	ast_ari_response_no_content(response);
+}
+
 void ast_ari_channels_answer(struct ast_variable *headers,
 	struct ast_ari_channels_answer_args *args,
 	struct ast_ari_response *response)
Index: res/ari/resource_channels.h
===================================================================
--- res/ari/resource_channels.h	(revision 430751)
+++ res/ari/resource_channels.h	(working copy)
@@ -221,6 +221,32 @@
  * \param[out] response HTTP response
  */
 void ast_ari_channels_continue_in_dialplan(struct ast_variable *headers, struct ast_ari_channels_continue_in_dialplan_args *args, struct ast_ari_response *response);
+/*! Argument struct for ast_ari_channels_redirect() */
+struct ast_ari_channels_redirect_args {
+	/*! Channel's id */
+	const char *channel_id;
+	/*! The endpoint to redirect the channel to */
+	const char *endpoint;
+};
+/*!
+ * \brief Body parsing function for /channels/{channelId}/redirect.
+ * \param body The JSON body from which to parse parameters.
+ * \param[out] args The args structure to parse into.
+ * \retval zero on success
+ * \retval non-zero on failure
+ */
+int ast_ari_channels_redirect_parse_body(
+	struct ast_json *body,
+	struct ast_ari_channels_redirect_args *args);
+
+/*!
+ * \brief Redirect the channel to a different location.
+ *
+ * \param headers HTTP headers
+ * \param args Swagger parameters
+ * \param[out] response HTTP response
+ */
+void ast_ari_channels_redirect(struct ast_variable *headers, struct ast_ari_channels_redirect_args *args, struct ast_ari_response *response);
 /*! Argument struct for ast_ari_channels_answer() */
 struct ast_ari_channels_answer_args {
 	/*! Channel's id */
Index: res/res_ari_channels.c
===================================================================
--- res/res_ari_channels.c	(revision 430751)
+++ res/res_ari_channels.c	(working copy)
@@ -707,7 +707,107 @@
 fin: __attribute__((unused))
 	return;
 }
+int ast_ari_channels_redirect_parse_body(
+	struct ast_json *body,
+	struct ast_ari_channels_redirect_args *args)
+{
+	struct ast_json *field;
+	/* Parse query parameters out of it */
+	field = ast_json_object_get(body, "endpoint");
+	if (field) {
+		args->endpoint = ast_json_string_get(field);
+	}
+	return 0;
+}
+
 /*!
+ * \brief Parameter parsing callback for /channels/{channelId}/redirect.
+ * \param get_params GET parameters in the HTTP request.
+ * \param path_vars Path variables extracted from the request.
+ * \param headers HTTP headers.
+ * \param[out] response Response to the HTTP request.
+ */
+static void ast_ari_channels_redirect_cb(
+	struct ast_tcptls_session_instance *ser,
+	struct ast_variable *get_params, struct ast_variable *path_vars,
+	struct ast_variable *headers, struct ast_ari_response *response)
+{
+	struct ast_ari_channels_redirect_args args = {};
+	struct ast_variable *i;
+	RAII_VAR(struct ast_json *, body, NULL, ast_json_unref);
+#if defined(AST_DEVMODE)
+	int is_valid;
+	int code;
+#endif /* AST_DEVMODE */
+
+	for (i = get_params; i; i = i->next) {
+		if (strcmp(i->name, "endpoint") == 0) {
+			args.endpoint = (i->value);
+		} else
+		{}
+	}
+	for (i = path_vars; i; i = i->next) {
+		if (strcmp(i->name, "channelId") == 0) {
+			args.channel_id = (i->value);
+		} else
+		{}
+	}
+	/* Look for a JSON request entity */
+	body = ast_http_get_json(ser, headers);
+	if (!body) {
+		switch (errno) {
+		case EFBIG:
+			ast_ari_response_error(response, 413, "Request Entity Too Large", "Request body too large");
+			goto fin;
+		case ENOMEM:
+			ast_ari_response_error(response, 500, "Internal Server Error", "Error processing request");
+			goto fin;
+		case EIO:
+			ast_ari_response_error(response, 400, "Bad Request", "Error parsing request body");
+			goto fin;
+		}
+	}
+	if (ast_ari_channels_redirect_parse_body(body, &args)) {
+		ast_ari_response_alloc_failed(response);
+		goto fin;
+	}
+	ast_ari_channels_redirect(headers, &args, response);
+#if defined(AST_DEVMODE)
+	code = response->response_code;
+
+	switch (code) {
+	case 0: /* Implementation is still a stub, or the code wasn't set */
+		is_valid = response->message == NULL;
+		break;
+	case 500: /* Internal Server Error */
+	case 501: /* Not Implemented */
+	case 400: /* Endpoint parameter not provided */
+	case 404: /* Channel or endpoint not found */
+	case 409: /* Channel not in a Stasis application */
+	case 422: /* Endpoint is not the same type as the channel */
+		is_valid = 1;
+		break;
+	default:
+		if (200 <= code && code <= 299) {
+			is_valid = ast_ari_validate_void(
+				response->message);
+		} else {
+			ast_log(LOG_ERROR, "Invalid error response %d for /channels/{channelId}/redirect\n", code);
+			is_valid = 0;
+		}
+	}
+
+	if (!is_valid) {
+		ast_log(LOG_ERROR, "Response validation failed for /channels/{channelId}/redirect\n");
+		ast_ari_response_error(response, 500,
+			"Internal Server Error", "Response validation failed");
+	}
+#endif /* AST_DEVMODE */
+
+fin: __attribute__((unused))
+	return;
+}
+/*!
  * \brief Parameter parsing callback for /channels/{channelId}/answer.
  * \param get_params GET parameters in the HTTP request.
  * \param path_vars Path variables extracted from the request.
@@ -2462,6 +2562,15 @@
 	.children = {  }
 };
 /*! \brief REST handler for /api-docs/channels.{format} */
+static struct stasis_rest_handlers channels_channelId_redirect = {
+	.path_segment = "redirect",
+	.callbacks = {
+		[AST_HTTP_POST] = ast_ari_channels_redirect_cb,
+	},
+	.num_children = 0,
+	.children = {  }
+};
+/*! \brief REST handler for /api-docs/channels.{format} */
 static struct stasis_rest_handlers channels_channelId_answer = {
 	.path_segment = "answer",
 	.callbacks = {
@@ -2595,8 +2704,8 @@
 		[AST_HTTP_POST] = ast_ari_channels_originate_with_id_cb,
 		[AST_HTTP_DELETE] = ast_ari_channels_hangup_cb,
 	},
-	.num_children = 12,
-	.children = { &channels_channelId_continue,&channels_channelId_answer,&channels_channelId_ring,&channels_channelId_dtmf,&channels_channelId_mute,&channels_channelId_hold,&channels_channelId_moh,&channels_channelId_silence,&channels_channelId_play,&channels_channelId_record,&channels_channelId_variable,&channels_channelId_snoop, }
+	.num_children = 13,
+	.children = { &channels_channelId_continue,&channels_channelId_redirect,&channels_channelId_answer,&channels_channelId_ring,&channels_channelId_dtmf,&channels_channelId_mute,&channels_channelId_hold,&channels_channelId_moh,&channels_channelId_silence,&channels_channelId_play,&channels_channelId_record,&channels_channelId_variable,&channels_channelId_snoop, }
 };
 /*! \brief REST handler for /api-docs/channels.{format} */
 static struct stasis_rest_handlers channels = {
Index: res/res_pjsip_multihomed.c
===================================================================
--- res/res_pjsip_multihomed.c	(revision 430751)
+++ res/res_pjsip_multihomed.c	(working copy)
@@ -145,12 +145,14 @@
 	if (tdata->msg->type == PJSIP_REQUEST_MSG || !(cseq = pjsip_msg_find_hdr(tdata->msg, PJSIP_H_CSEQ, NULL)) ||
 		pj_strcmp2(&cseq->method.name, "REGISTER")) {
 		pjsip_contact_hdr *contact = pjsip_msg_find_hdr(tdata->msg, PJSIP_H_CONTACT, NULL);
-		if (contact && (PJSIP_URI_SCHEME_IS_SIP(contact->uri) || PJSIP_URI_SCHEME_IS_SIPS(contact->uri))) {
+		if (contact && tdata->msg->line.status.code != 302
+			&& (PJSIP_URI_SCHEME_IS_SIP(contact->uri) || PJSIP_URI_SCHEME_IS_SIPS(contact->uri))) {
 			pjsip_sip_uri *uri = pjsip_uri_get_uri(contact->uri);
 
 			/* prm.ret_addr is allocated from the tdata pool so it is perfectly fine to just do an assignment like this */
 			pj_strassign(&uri->host, &prm.ret_addr);
 			uri->port = prm.ret_port;
+			ast_debug(4, "Re-wrote Contact URI host/port to %s:%d\n", pj_strbuf(&uri->host), uri->port);
 
 			pjsip_tx_data_invalidate_msg(tdata);
 		}
Index: res/res_pjsip_nat.c
===================================================================
--- res/res_pjsip_nat.c	(revision 430751)
+++ res/res_pjsip_nat.c	(working copy)
@@ -52,6 +52,7 @@
 			uri->transport_param.slen = 0;
 		}
 		uri->port = rdata->pkt_info.src_port;
+		ast_debug(4, "Re-wrote Contact URI host/port to %s:%d\n", pj_strbuf(&uri->host), uri->port);
 
 		/* rewrite the session target since it may have already been pulled from the contact header */
 		if (dlg && (!dlg->remote.contact
@@ -205,6 +206,7 @@
 		pj_strdup2(tdata->pool, &uri->host, ast_sockaddr_stringify_host(&transport->external_address));
 		if (transport->external_signaling_port) {
 			uri->port = transport->external_signaling_port;
+			ast_debug(4, "Re-wrote Contact URI port to %d\n", uri->port);
 		}
 	}
 
Index: res/res_pjsip_transport_websocket.c
===================================================================
--- res/res_pjsip_transport_websocket.c	(revision 430751)
+++ res/res_pjsip_transport_websocket.c	(working copy)
@@ -329,6 +329,7 @@
 
 		pj_cstr(&uri->host, rdata->pkt_info.src_name);
 		uri->port = rdata->pkt_info.src_port;
+		ast_debug(4, "Re-wrote Contact URI host/port to %s:%d\n", pj_strbuf(&uri->host), uri->port);
 		pj_strdup(rdata->tp_info.pool, &uri->transport_param, (type == (long)transport_type_ws) ? &STR_WS : &STR_WSS);
 	}
 
Index: res/stasis/control.c
===================================================================
--- res/stasis/control.c	(revision 430751)
+++ res/stasis/control.c	(working copy)
@@ -428,6 +428,38 @@
 	return 0;
 }
 
+static int app_control_redirect(struct stasis_app_control *control,
+	struct ast_channel *chan, void *data)
+{
+	char *endpoint = data;
+	int res;
+
+	ast_assert(control->channel != NULL);
+	ast_assert(endpoint != NULL);
+
+	res = ast_transfer(control->channel, endpoint);
+	if (!res) {
+		ast_log(LOG_NOTICE, "Unsupported transfer requested on channel '%s'\n",
+			ast_channel_name(control->channel));
+		return 0;
+	}
+
+	return 0;
+}
+
+int stasis_app_control_redirect(struct stasis_app_control *control, const char *endpoint)
+{
+	char *endpoint_data = ast_strdup(endpoint);
+
+	if (!endpoint_data) {
+		return -1;
+	}
+
+	stasis_app_send_command_async(control, app_control_redirect, endpoint_data, ast_free_ptr);
+
+	return 0;
+}
+
 struct stasis_app_control_dtmf_data {
 	int before;
 	int between;
Index: rest-api/api-docs/channels.json
===================================================================
--- rest-api/api-docs/channels.json	(revision 430751)
+++ rest-api/api-docs/channels.json	(working copy)
@@ -396,6 +396,54 @@
 			]
 		},
 		{
+			"path": "/channels/{channelId}/redirect",
+			"description": "Inform the channel that it should redirect itself to a different location. Note that this will almost certainly cause the channel to exit the application.",
+			"operations": [
+				{
+					"httpMethod": "POST",
+					"summary": "Redirect the channel to a different location.",
+					"nickname": "redirect",
+					"responseClass": "void",
+					"parameters": [
+						{
+							"name": "channelId",
+							"description": "Channel's id",
+							"paramType": "path",
+							"required": true,
+							"allowMultiple": false,
+							"dataType": "string"
+						},
+						{
+							"name": "endpoint",
+							"description": "The endpoint to redirect the channel to",
+							"paramType": "query",
+							"required": true,
+							"allowMultiple": false,
+							"dataType": "string"
+						}
+					],
+					"errorResponses": [
+						{
+							"code": 400,
+							"reason": "Endpoint parameter not provided"
+						},
+						{
+							"code": 404,
+							"reason": "Channel or endpoint not found"
+						},
+						{
+							"code": 409,
+							"reason": "Channel not in a Stasis application"
+						},
+						{
+							"code": 422,
+							"reason": "Endpoint is not the same type as the channel"
+						}
+					]
+				}
+			]
+		},
+		{
 			"path": "/channels/{channelId}/answer",
 			"description": "Answer a channel",
 			"operations": [