diff --git a/funcs/func_enum.c b/funcs/func_enum.c
index 58a05c0..22a3460 100644
--- a/funcs/func_enum.c
+++ b/funcs/func_enum.c
@@ -81,7 +81,7 @@ ASTERISK_REGISTER_FILE()
 			<parameter name="resultnum" required="true">
 				<para>The number of the result that you want to retrieve.</para>
 				<para>Results start at <literal>1</literal>. If this argument is specified
-				as <literal>getnum</literal>, then it will return the total number of results 
+				as <literal>getnum</literal>, then it will return the total number of results
 				that are available or -1 on error.</para>
 			</parameter>
 		</syntax>
@@ -122,7 +122,7 @@ ASTERISK_REGISTER_FILE()
 				</optionlist>	
 			</parameter>
 			<parameter name="record#">
-				<para>If no <replaceable>record#</replaceable> is given, 
+				<para>If no <replaceable>record#</replaceable> is given,
 				defaults to <literal>1</literal>.</para>
 			</parameter>
 			<parameter name="zone-suffix">
diff --git a/funcs/func_global.c b/funcs/func_global.c
index 23e69d3..0b517b9 100644
--- a/funcs/func_global.c
+++ b/funcs/func_global.c
@@ -72,7 +72,7 @@ ASTERISK_REGISTER_FILE()
 			<para>Implements a shared variable area, in which you may share variables between
 			channels.</para>
 			<para>The variables used in this space are separate from the general namespace of
-			the channel and thus <variable>SHARED(foo)</variable> and <variable>foo</variable> 
+			the channel and thus <variable>SHARED(foo)</variable> and <variable>foo</variable>
 			represent two completely different variables, despite sharing the same name.</para>
 			<para>Finally, realize that there is an inherent race between channels operating
 			at the same time, fiddling with each others' internal variables, which is why
diff --git a/funcs/func_groupcount.c b/funcs/func_groupcount.c
index 9708ca7..0e0c9d8 100644
--- a/funcs/func_groupcount.c
+++ b/funcs/func_groupcount.c
@@ -81,7 +81,7 @@ ASTERISK_REGISTER_FILE()
 			</parameter>
 		</syntax>
 		<description>
-			<para><replaceable>category</replaceable> can be employed for more fine grained group management. Each channel 
+			<para><replaceable>category</replaceable> can be employed for more fine grained group management. Each channel
 			can only be member of exactly one group per <replaceable>category</replaceable>.</para>
 		</description>
 	</function>
diff --git a/funcs/func_lock.c b/funcs/func_lock.c
index 7bb50f5..2a9b411 100644
--- a/funcs/func_lock.c
+++ b/funcs/func_lock.c
@@ -75,7 +75,7 @@ ASTERISK_REGISTER_FILE()
 		</syntax>
 		<description>
 			<para>Attempts to grab a named lock exclusively, and prevents other channels
-			from obtaining the same lock.  Returns <literal>1</literal> if the lock was 
+			from obtaining the same lock.  Returns <literal>1</literal> if the lock was
 			available or <literal>0</literal> otherwise.</para>
 			<note>
 				<para>If <literal>live_dangerously</literal> in <literal>asterisk.conf</literal>
@@ -92,9 +92,9 @@ ASTERISK_REGISTER_FILE()
 			<parameter name="lockname" required="true" />
 		</syntax>
 		<description>
-			<para>Unlocks a previously locked mutex. Returns <literal>1</literal> if the channel 
+			<para>Unlocks a previously locked mutex. Returns <literal>1</literal> if the channel
 			had a lock or <literal>0</literal> otherwise.</para>
-			<note><para>It is generally unnecessary to unlock in a hangup routine, as any locks 
+			<note><para>It is generally unnecessary to unlock in a hangup routine, as any locks
 			held are automatically freed when the channel is destroyed.</para></note>
 			<note>
 				<para>If <literal>live_dangerously</literal> in <literal>asterisk.conf</literal>
diff --git a/funcs/func_odbc.c b/funcs/func_odbc.c
index 224cd7a..ded8cfa 100644
--- a/funcs/func_odbc.c
+++ b/funcs/func_odbc.c
@@ -56,8 +56,8 @@ ASTERISK_REGISTER_FILE()
 			<parameter name="result-id" required="true" />
 		</syntax>
 		<description>
-			<para>For queries which are marked as mode=multirow, the original 
-			query returns a <replaceable>result-id</replaceable> from which results 
+			<para>For queries which are marked as mode=multirow, the original
+			query returns a <replaceable>result-id</replaceable> from which results
 			may be fetched.  This function implements the actual fetch of the results.</para>
 			<para>This also sets <variable>ODBC_FETCH_STATUS</variable>.</para>
 			<variablelist>
@@ -80,7 +80,7 @@ ASTERISK_REGISTER_FILE()
 			<parameter name="result-id" required="true" />
 		</syntax>
 		<description>
-			<para>For queries which are marked as mode=multirow, this will clear 
+			<para>For queries which are marked as mode=multirow, this will clear
 			any remaining rows of the specified resultset.</para>
 		</description>
 	</application>
@@ -92,7 +92,7 @@ ASTERISK_REGISTER_FILE()
 			<parameter name="string" required="true" />
 		</syntax>
 		<description>
-			<para>Used in SQL templates to escape data which may contain single ticks 
+			<para>Used in SQL templates to escape data which may contain single ticks
 			<literal>'</literal> which are otherwise used to delimit data.</para>
 			<para>Example: SELECT foo FROM bar WHERE baz='${SQL_ESC(${ARG1})}'</para>
 		</description>
diff --git a/funcs/func_rand.c b/funcs/func_rand.c
index cc34517..c5df6ac 100644
--- a/funcs/func_rand.c
+++ b/funcs/func_rand.c
@@ -48,8 +48,8 @@ ASTERISK_REGISTER_FILE()
 			<parameter name="max" />
 		</syntax>
 		<description>
-			<para>Choose a random number between <replaceable>min</replaceable> and <replaceable>max</replaceable>. 
-			<replaceable>min</replaceable> defaults to <literal>0</literal>, if not specified, while <replaceable>max</replaceable> defaults 
+			<para>Choose a random number between <replaceable>min</replaceable> and <replaceable>max</replaceable>.
+			<replaceable>min</replaceable> defaults to <literal>0</literal>, if not specified, while <replaceable>max</replaceable> defaults
 			to <literal>RAND_MAX</literal> (2147483647 on many systems).</para>
 			<para>Example:  Set(junky=${RAND(1,8)});
 			Sets junky to a random number between 1 and 8, inclusive.</para>
diff --git a/funcs/func_speex.c b/funcs/func_speex.c
index a4cfa17..39788e9 100644
--- a/funcs/func_speex.c
+++ b/funcs/func_speex.c
@@ -65,7 +65,7 @@ ASTERISK_REGISTER_FILE()
 			channel that it is executed on. Using <literal>rx</literal> for audio received
 			and <literal>tx</literal> for audio transmitted to the channel. When using this
 			function you set a target audio level. It is primarily intended for use with
-			analog lines, but could be useful for other channels as well. The target volume 
+			analog lines, but could be useful for other channels as well. The target volume
 			is set with a number between <literal>1-32768</literal>. The larger the number
 			the louder (more gain) the channel will receive.</para>
 			<para>Examples:</para>
@@ -79,7 +79,7 @@ ASTERISK_REGISTER_FILE()
 		</synopsis>
 		<syntax>
 			<parameter name="channeldirection" required="true">
-				<para>This can be either <literal>rx</literal> or <literal>tx</literal> 
+				<para>This can be either <literal>rx</literal> or <literal>tx</literal>
 				the values that can be set to this are either <literal>on</literal> and
 				<literal>off</literal></para>
 			</parameter>
diff --git a/funcs/func_strings.c b/funcs/func_strings.c
index 255e846..ad58d54 100644
--- a/funcs/func_strings.c
+++ b/funcs/func_strings.c
@@ -108,13 +108,13 @@ AST_THREADSTORAGE(tmp_buf);
 			<parameter name="string" required="true" />
 		</syntax>
 		<description>
-			<para>Permits all characters listed in <replaceable>allowed-chars</replaceable>, 
-			filtering all others outs. In addition to literally listing the characters, 
+			<para>Permits all characters listed in <replaceable>allowed-chars</replaceable>,
+			filtering all others outs. In addition to literally listing the characters,
 			you may also use ranges of characters (delimited by a <literal>-</literal></para>
 			<para>Hexadecimal characters started with a <literal>\x</literal>(i.e. \x20)</para>
 			<para>Octal characters started with a <literal>\0</literal> (i.e. \040)</para>
-			<para>Also <literal>\t</literal>,<literal>\n</literal> and <literal>\r</literal> are recognized.</para> 
-			<note><para>If you want the <literal>-</literal> character it needs to be prefixed with a 
+			<para>Also <literal>\t</literal>,<literal>\n</literal> and <literal>\r</literal> are recognized.</para>
+			<note><para>If you want the <literal>-</literal> character it needs to be prefixed with a
 			<literal>\</literal></para></note>
 		</description>
 	</function>
@@ -181,9 +181,9 @@ AST_THREADSTORAGE(tmp_buf);
 		</syntax>
 		<description>
 			<para>Return <literal>1</literal> on regular expression match or <literal>0</literal> otherwise</para>
-			<para>Please note that the space following the double quotes separating the 
-			regex from the data is optional and if present, is skipped. If a space is 
-			desired at the beginning of the data, then put two spaces there; the second 
+			<para>Please note that the space following the double quotes separating the
+			regex from the data is optional and if present, is skipped. If a space is
+			desired at the beginning of the data, then put two spaces there; the second
 			will not be skipped.</para>
 		</description>
 	</function>
@@ -220,8 +220,8 @@ AST_THREADSTORAGE(tmp_buf);
 			<parameter name="hashname" required="true" />
 		</syntax>
 		<description>
-			<para>Returns a comma-delimited list of the current keys of the associative array 
-			defined by the HASH() function. Note that if you iterate over the keys of 
+			<para>Returns a comma-delimited list of the current keys of the associative array
+			defined by the HASH() function. Note that if you iterate over the keys of
 			the result, adding keys during iteration will cause the result of the HASHKEYS()
 			function to change.</para>
 		</description>
@@ -247,8 +247,8 @@ AST_THREADSTORAGE(tmp_buf);
 			<parameter name="varN" required="false" />
 		</syntax>
 		<description>
-			<para>The comma-delimited list passed as a value to which the function is set will 
-			be interpreted as a set of values to which the comma-delimited list of 
+			<para>The comma-delimited list passed as a value to which the function is set will
+			be interpreted as a set of values to which the comma-delimited list of
 			variable names in the argument should be set.</para>
 			<para>Example: Set(ARRAY(var1,var2)=1,2) will set var1 to 1 and var2 to 2</para>
 		</description>
@@ -263,7 +263,7 @@ AST_THREADSTORAGE(tmp_buf);
 			<parameter name="format" required="true" />
 		</syntax>
 		<description>
-			<para>This is useful for converting a date into <literal>EPOCH</literal> time, 
+			<para>This is useful for converting a date into <literal>EPOCH</literal> time,
 			possibly to pass to an application like SayUnixTime or to calculate the difference
 			between the two date strings</para>
 			<para>Example: ${STRPTIME(2006-03-01 07:30:35,America/Chicago,%Y-%m-%d %H:%M:%S)} returns 1141219835</para>
diff --git a/funcs/func_timeout.c b/funcs/func_timeout.c
index 1cb6b8d..5b29bab 100644
--- a/funcs/func_timeout.c
+++ b/funcs/func_timeout.c
@@ -46,7 +46,7 @@ ASTERISK_REGISTER_FILE()
 		<syntax>
 			<parameter name="timeouttype" required="true">
 				<para>The timeout that will be manipulated. The possible timeout types
-				are: <literal>absolute</literal>, <literal>digit</literal> or 
+				are: <literal>absolute</literal>, <literal>digit</literal> or
 				<literal>response</literal></para>
 			</parameter>
 		</syntax>
diff --git a/funcs/func_vmcount.c b/funcs/func_vmcount.c
index 2c35631..6fa13e4 100644
--- a/funcs/func_vmcount.c
+++ b/funcs/func_vmcount.c
@@ -55,7 +55,7 @@ ASTERISK_REGISTER_FILE()
 			</parameter>
 		</syntax>
 		<description>
-			<para>Count the number of voicemails in a specified mailbox, you could also specify 
+			<para>Count the number of voicemails in a specified mailbox, you could also specify
 			the mailbox <replaceable>folder</replaceable>.</para>
 			<para>Example: <literal>exten => s,1,Set(foo=${VMCOUNT(125@default)})</literal></para>
 		</description>